#include "main.h"

extern p_s PS;

// LCD Interface 
void lcdinterface(char * ID, int paper, int now_page)
{
    time_t timer;
    struct tm *t;
    char * current_state;
    switch(PS.print_current_state)
    {
        case 0 : 
        current_state = "휴 식 중";
        break;
        case 1 : 
        current_state = "인 쇄 중";
        break;
        case 2 : 
        current_state = "충 전 중";
        break;
    }
    
    timer = time(NULL);
    
    t = localtime(&timer);

    
    printf("================NPS==================\n");
    printf("\n");
    printf("      %d년 %d월 %d일 %d시 %d분 \n", t->tm_year+1900, t->tm_mon+1, t->tm_mday, t->tm_hour, t->tm_min);
    printf("       현재 사용자  %s          \n", ID);
    printf("\n");
    printf("       현재 상 태   %s       \n", current_state);
    printf("\n");
    printf("       현재 진행량  %d/%d            \n", now_page, paper);
    printf("\n");
    printf("       잔여 잉크량  %d           \n", PS.current_ink);
    printf("\n");
    printf("       잔여 용지량  %d             \n", PS.current_paper);
    printf("\n");
    printf("       대기자   수  %d              \n", PS.wait_num);
    printf("\n");
    printf("=====================================\n");

    sleep(1);
    
}

void alarm_error(int error_code)
{
    switch(error_code)
    {
        case 1:
        // 충전 중 이거나 인쇄 중인데 대기자 수가 최대라서 더이상 대기 불가능
        printf(" Warning !! \n");
        printf(" 이미 대기자 수가 많아 인쇄 대기할 수 없습니다. \n");
        break;
        case 2:
        // 인쇄 조건 충족 못했을 때
        printf(" Warning !! \n");
        printf(" 인쇄할 파일이 인쇄 조건을 만족하지 못했습니다. \n");
        break;
        case 3:
        // 중지 명령 했는데 현재 인쇄 중이 아닐 때
        printf(" Warning !! \n");
        printf(" 현재 인쇄 중이 아닙니다. \n");
        break;
        case 4:
        // 충전 명령 했는데 현재 인쇄 중일 때
        printf(" Warning !! \n");
        printf(" 현재 인쇄 중이므로 충전할 수 없습니다. \n");
        break;
        case 5:
        // 충전하면 최대 용지 량 초과할 때
        printf(" Warning !! \n");
        printf(" 용지를 충전하면 최대 용지 량을 초과합니다. \n");
        printf(" 용지를 최대치로 충전합니다. \n");
        break;
        case 6:
        // 충전하면 최대 잉크량 초과할 때
        printf(" Warning !! \n");
        printf(" 잉크를 충전하면 최대 잉크 량을 초과합니다. \n");
        printf(" 잉크를 최대치로 충전합니다. \n");
        break;
        case 7:
        // 유저 추가, 삭제, 보여주기 명령 했는데 휴식 중이 아닐 때
        printf(" Warning !! \n");
        printf(" 휴식 중이 아니므로 명령을 수행할 수 없습니다. \n");
        break;
        case 8:
        // 등록할 사람이 이미 존재 할 때
        printf(" Warning !! \n");
        printf(" 등록할 사용자가 이미 존재합니다. \n");
        break;
        case 9:
        // 삭제할 사람이 존재 하지 않을 때
        printf(" Warning !! \n");
        printf(" 삭제할 사용자가 존재하지 않습니다. \n");
        break;
        case 10:
        // 충전 요청인데 이미 충전 중
        printf(" Warning !! \n");
        printf(" 현재 충전 중이므로 또 다른 충전을 수행할 수 없습니다. \n");
        
    }
    usleep(500000);
}