#include "main.h"

extern p_s PS;

int print_controller_state; // 1 인쇄(대기자 없음) 2 인쇄(대기자 있음) 3 정지 4 에러

void add_wait(p_t PT)
{
    FILE * fp = fopen("wait.txt", "a");
    
    fprintf(fp, "%s,%s,%d\n", PT.ID, PT.file, PT.calculated_paper);
    
    if((PS.print_current_state == 1) || (PS.print_current_state == 2))
    {
        PS.wait_num ++;
    }
    PS.temp_ink -= PT.calculated_ink;
    PS.temp_paper -= PT.calculated_paper;
    
    fclose(fp);
}

void read_print(p_t *PT) // print.txt 읽기
{
    FILE *fp = fopen("../print.txt", "r");
    
    fscanf(fp, "%s %s %d %d %d", PT->ID, PT->file, &(PT->calculated_ink), &(PT->calculated_paper), &(PT->verified_file));
    
    fclose(fp);
   
}



void printcontroller(int command)
{
    int error_code; // error_code 에 따라 LCD 화면에 출력
    print_controller_state = 2;
    
    p_t PT;
    PT.ID  = (char *)malloc(sizeof(char)*11);
    PT.file = (char *)malloc(sizeof(char)*20);
    
    read_print(&PT);

    if(command == 1) // 명령이 인쇄
    {
       if((PT.verified_file == 1) && (PT.calculated_ink < PS.temp_ink) && (PT.calculated_paper < PS.temp_paper))
       {
            if(PS.print_current_state == 0) // 휴식중
            {
                print_controller_state = 1;
                add_wait(PT);
                read_wait();
            }
            else if(PS.print_current_state == 1) // 인쇄중
            {
                if(PS.wait_num <5)
                {
                    print_controller_state = 2;
                    
                    add_wait(PT);
                }
                else
                {
                    print_controller_state = 4;
                    error_code = 1; // 대기자 수가 5보다 크거나 같을 때
                    alarm_error(error_code);
                }
            }
            else if(PS.print_current_state == 2) // 충전중 
            {
                if(PS.wait_num <5)
                {
                    print_controller_state = 2;
                    add_wait(PT);
                }
                else
                {
                    print_controller_state = 4;
                    error_code = 1;
                    alarm_error(error_code);
                }
            }
       }
       else
       {
            print_controller_state = 4;
            error_code = 2; // 조건 충족 못했을 때
            alarm_error(error_code);
       }
    }
    else if(command == 2) // 중지 명령
    {
        if(PS.print_current_state != 1)
        {
            print_controller_state = 4;
            error_code = 3; // 현재 인쇄 중이 아닐 때
            alarm_error(error_code);
        }
        else
        {
            print_controller_state = 3;
        }
    }
    
}